# -*- coding: utf-8 -*-
from setuphelpers import *
import os


def update_package():
    wget(
        "http://srvtemplates.ad.tranquil.it/binary_cache/windres",
        "/usr/local/bin/windres",
        sha256="035d0036e0968c4b21fe180b1938694baaf3cb78b8a0c146559e6d8fbedb7e06",
    )
    run("chown root:wheel /usr/local/bin/windres")
    run("chmod 755 /usr/local/bin/windres")
    # Compile
    mkdirs("/var/build")
    run("git clone https://gitea.ad.tranquil.it/tis-internal-tools/tis-rsat.git /var/build")    # todo
    version = "0.0.%s" % run(r"git -C /var/build rev-list --count main").strip()
    control.set_software_version(version)
    control.save_control_to_wapt()
    run(r'git -C /var/build submodule update --progress --init -- "submodules/mORMot2"')
    run(r'git -C /var/build submodule update --progress --init -- "submodules/pltis_uicomponents"')
    run(r'git -C /var/build submodule update --progress --init -- "submodules/pltis_tsmbios"')
    run(r'git -C /var/build submodule update --progress --init -- "submodules/pltis_utils"')
    run(r'git -C /var/build submodule update --progress --init -- "submodules/pltis_virtualtrees"')
    run(r'git -C /var/build submodule update --progress --init -- "submodules/metadarkstyle"')

    wget('https://synopse.info/files/mormot2static.7z','mormot2static.7z')
    run('/usr/local/bin/7zz x -y mormot2static.7z -ostatic')
    remove_tree(r'/var/build/submodules/mORMot2/static')
    os.rename('static',r'/var/build/submodules/mORMot2/static')
    remove_file('mormot2static.7z')

    run('/Applications/Lazarus/lazbuild --add-package-link /var/build/submodules/mORMot2/packages/lazarus/mormot2.lpk --ws=cocoa')
    run('/Applications/Lazarus/lazbuild --add-package-link /var/build/submodules/pltis_uicomponents/pack/pltis_uicomponents.lpk --ws=cocoa')
    run('/Applications/Lazarus/lazbuild --add-package-link /var/build/submodules/pltis_tsmbios/Packages/tsmbios.lpk')
    run('/Applications/Lazarus/lazbuild --add-package-link /var/build/submodules/pltis_utils/pltis_utils.lpk ')
    run('/Applications/Lazarus/lazbuild --add-package /var/build/submodules/pltis_virtualtrees/virtualtreeview_package.lpk')
    run('/Applications/Lazarus/lazbuild --add-package /var/build/submodules/metadarkstyle/metadarkstyle.lpk')
    run('/Applications/Lazarus/lazbuild --add-package /var/build/submodules/metadarkstyle/metadarkstyledsgn.lpk')

    run("/Applications/Lazarus/lazbuild --build-mode=macosx-intel /var/build/src/tisrsat.lpi --ws=cocoa")
    # WAPT PAckage prepare
    filecopyto("/var/build/bin/macosx-intel/tisrsat", "RsatConsole")
